diff --git a/src/doc/screen.1 b/src/doc/screen.1
index ff2fe82..40ffacd 100644
--- a/src/doc/screen.1
+++ b/src/doc/screen.1
@@ -2145,7 +2145,10 @@ Subsequent pages will display the custom commands, one command per key.
 Press space when you're done reading each page, or return to exit early.
 All other characters are ignored. If the \*Q-c\*U option is given,
 display all bound commands for the specified command class.
-See also \*QDEFAULT KEY BINDINGS\*U section.
+See also \*QDEFAULT KEY BINDINGS\*U section. See also the \*Qlicense\*U
+command to find what capabilities have been compiled in the 
+.I screen
+command.
 .sp
 .ne 3
 .B history
@@ -2380,8 +2383,14 @@ will save or append the layout to the user's \fI.screenrc\fP file.
 .PP
 Display the disclaimer page. This is done whenever
 .I screen
-is started without options, which should be often enough. See also 
-the \*Qstartup_message\*U command.
+is started without options, which should be often enough. 
+.I License
+will also show what capabilities or compile-time options
+.I screen
+was created with. See also the \*Qstartup_message\*U command.
+
+\*QLicense\*U needs a region size of at least 10 characters wide
+and 5 characters high in order to display.
 .sp
 .ne 3
 .B lockscreen
@@ -2919,7 +2928,9 @@ When a new window is established, the first available number
 is assigned to this window.
 Thus, the first window can be activated by \*Qselect 0\*U.
 The number of windows is limited at compile-time by the MAXWIN
-configuration parameter (which defaults to 40).
+configuration parameter (which defaults to 40). See also the
+\*Qlicense\*U command to find what capabilities have been
+into the \*Qscreen\*U program.
 There are two special WindowIDs, \*Q-\*U selects the
 internal blank window and \*Q.\*U selects the current window. The
 latter is useful if used with screen's \*Q-X\*U option.
diff --git a/src/doc/screen.texinfo b/src/doc/screen.texinfo
index 539f23d..9a702bd 100644
--- a/src/doc/screen.texinfo
+++ b/src/doc/screen.texinfo
@@ -1245,7 +1245,8 @@ This section describes the commands for creating a new window for
 running programs.  When a new window is created, the first available
 number is assigned to it.
 The number of windows is limited at compile-time by the MAXWIN
-configuration parameter (which defaults to 40).
+configuration parameter (which defaults to 40). @xref{License}
+to find what capabilities have been compiled to @code{screen}.
 
 @menu
 * Chdir::                       Change the working directory for new windows.
@@ -1561,7 +1562,8 @@ When a new window is established, the lowest available number
 is assigned to this window.
 Thus, the first window can be activated by @code{select 0}; there
 can be no more than 10 windows present simultaneously (unless screen is
-compiled with a higher MAXWIN setting).
+compiled with a higher MAXWIN setting. @xref{License} to find what
+capabilities have been compiled to @code{screen}).
 There are two special arguments, @code{select -} switches to the
 internal blank window and @code{select .} switches to the
 current window. The latter is useful if used with screen's
@@ -4145,6 +4147,8 @@ All other characters are ignored.
 If the @samp{-c} option is given, display all bound commands for the
 specified command class.
 @xref{Default Key Bindings}.
+@xref{License} to find what capabilities have been compiled in the
+@code{screen} program.
 @end deffn
 
 @node Bindkey, Bindkey Examples, Help, Key Binding
@@ -5129,7 +5133,12 @@ be turned off once and forever.
 @deffn Command license
 (@kbd{C-a ,})@*
 Display the disclaimer page. This is done whenever @code{screen} is
-started without options, which should be often enough.
+started without options, which should be often enough. @code{License}
+will also show what capabilities or compile-time options @code{screen}
+was created with. @xref{Startup}.
+
+@code{License} needs a region size of at least 10 characters
+wide and 5 characters high in order to display.
 @end deffn
 
 @node Nethack, Nonblock, License, Miscellaneous
diff --git a/src/help.c b/src/help.c
index 8726b1b..a9951f9 100644
--- a/src/help.c
+++ b/src/help.c
@@ -574,6 +574,24 @@ screen-devel@gnu.org\n\n\n"
 "-font "
 #endif
 
+#ifdef UTF8
+"+utf8 "
+#else
+"-utf8 "
+#endif
+
+#ifdef DW_CHARS
+"+dw_chars "
+#else
+"-dw_chars "
+#endif
+
+#ifdef ENCODINGS
+"+encodings "
+#else
+"-encodings "
+#endif
+
 #ifdef COLORS256
 "+color-256 "
 #elif defined(COLORS16)
@@ -584,12 +602,6 @@ screen-devel@gnu.org\n\n\n"
 "-color "
 #endif
 
-#ifdef UTF8
-"+utf8 "
-#else
-"-utf8 "
-#endif
-
 #ifdef RXVT_OSC
 "+rxvt "
 #else
@@ -601,6 +613,78 @@ screen-devel@gnu.org\n\n\n"
 #else
 "-builtin-telnet "
 #endif
+
+#ifdef LOCK
+"+lock "
+#else
+"-lock "
+#endif
+
+#ifdef PASSWORD
+"+password "
+#else
+"-password "
+#endif
+
+#ifdef AUTO_NUKE
+"+auto_nuke "
+#else
+"-auto_nuke "
+#endif
+
+#ifdef PSEUDOS
+"+pseudos "
+#else
+"-pseudos "
+#endif
+
+#ifdef MAPKEYS
+"+mapkeys "
+#else
+"-mapkeys "
+#endif
+
+#ifdef DEBUG
+"+debug "
+#else
+"-debug "
+#endif
+
+#ifdef NETHACK
+"+nethack "
+#else
+"-nethack "
+#endif
+
+#ifdef BLANKER_PRG
+"+blanker_prg "
+#else
+"-blanker_prg "
+#endif
+
+#ifdef HAVE_BRAILLE
+"+have_braille "
+#else
+"-have_braille "
+#endif
+
+#ifdef LOADAV
+"+loadav "
+#else
+"-loadav "
+#endif
+
+#ifdef ZMODEM
+"+zmodem "
+#else
+"-zmodem "
+#endif
+
+#ifdef MAXWIN
+"+maxwin = MAXWIN "
+#else
+"-maxwin "
+#endif
 ;
 
 static void